/*
 * Copyright 2008 Kyoto University and Honda Motor Co.,Ltd.
 * All rights reserved.
 * HARK was developed by researchers in Okuno Laboratory
 * at the Kyoto University and Honda Research Institute Japan Co.,Ltd.
 */


/*
 * dimpro.hpp
 *
 *  Created on: 2010/11/18
 *      Author: HARK Development Team
 */

/**
 * @file dimpro.hpp
 * 次元保証ライブラリ.
 * 物理学・数学などでは、数値の次元（単位）が重要な意味をもつ。
 * しかし、C/C++において数値演算をする際につかう浮動小数点型には
 * 次元という概念が存在しない。
 * この次元保証ライブラリは、複数の次元が入り混じる計算でも、
 * 次元の正確さを保証する。
 *
 * また、次元の正確さを保証するための実行時のコストは0である。
 * 具体的には、最適化コンパイル（gccではO3程度）をすれば、
 * すべて組み込み型のみで計算した場合とほぼ同じバイナリになる
 * ということだ。
 */

#ifndef DIMPRO_HPP_
#define DIMPRO_HPP_

#include "types.hpp"
#include "operators.hpp"

#endif /* DIMPRO_HPP_ */
